// ################################################################################################################################################################# //
// ###                                                          STEROWNIK  PULPITUI  MAKIETY  " STACJA WYSOKA "
// ###
// ###                                                                                                                                          Klaudiusz Dawid 2022
// ################################################################################################################################################################# //



// przyciski pulpitu //
#define key_a1      A0
#define key_a2      A1
#define key_b1      A2
#define key_c2      A3
#define key_d1      A4
#define key_e2      A5
#define key_f1      A6
#define key_f2      A7

#define key_rozw_przebiegu_1    A9
#define key_rozw_przebiegu_2    A8

#define key_Zw1     2
#define key_Zw2     3
#define key_Zw3_4   4
#define key_Zw5     5
#define key_Wk      6

#define key_SzA     7
#define key_SzB     8
#define key_SzC     9
#define key_SzD     10
#define key_SzE     11
#define key_SzF     12

// diody pulpitu //
#define led_A_czerwone    22
#define led_A_zielone     23
#define led_A_biale       24

#define led_B_czerwone    25
#define led_B_zielone     26
#define led_B_biale       27

#define led_C_czerwone    28
#define led_C_zielone     29
#define led_C_biale       30

#define led_D_czerwone    31
#define led_D_zielone     32
#define led_D_biale       33

#define led_E_czerwone    34
#define led_E_zielone     35
#define led_E_biale       36

#define led_F_czerwone    37
#define led_F_zielone     38
#define led_F_biale       39

#define led_Zw1_plus      40
#define led_Zw1_minus     41
#define led_Zw2_plus      42
#define led_Zw2_minus     43
#define led_Zw3_4_plus    44
#define led_Zw3_4_minus   45
#define led_Zw5_plus      46
#define led_Zw5_minus     47

#define led_a1            48
#define led_a2            49
#define led_b1            50
#define led_c2            51
#define led_d1            52
#define led_e2            53
#define led_f1            14
#define led_f2            15

#define led_Wk_otwarta    17
#define led_Wk_zamknieta  16
#define buzzer            18


int data;

int stan_Zw1 = 1;   // na wprost //
int stan_Zw2 = 1;   // na wprost //
int stan_Zw3_4 = 1; // na wprost //
int stan_Zw5 = 1;   // na wprost //
int stan_Wk = 1;    // zamknieta //

int stan_A = 1;     // S1 czerwone //
int stan_B = 1;     // S1 czerwone //
int stan_C = 1;     // S1 czerwone //
int stan_D = 1;     // S1 czerwone //
int stan_E = 1;     // S1 czerwone //
int stan_F = 1;     // S1 czerwone //

int utwierdzenie_Zw1 = 0;
int utwierdzenie_Zw2 = 0;
int utwierdzenie_Zw3_4 = 0;
int utwierdzenie_Zw5 = 0;
int utwierdzenie_Wk = 0;

int stan_a1 = 0;
int stan_a2 = 0;
int stan_b1 = 0;
int stan_c2 = 0;
int stan_d1 = 0;
int stan_e2 = 0;
int stan_f1 = 0;
int stan_f2 = 0;


int stan_SzA = 0;
int stan_SzB = 0;
int stan_SzC = 0;
int stan_SzD = 0;
int stan_SzE = 0;
int stan_SzF = 0;

unsigned long czas;
unsigned long czas_SzA = 0;
unsigned long czas_SzB = 0;
unsigned long czas_SzC = 0;
unsigned long czas_SzD = 0;
unsigned long czas_SzE = 0;
unsigned long czas_SzF = 0;



// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   S E T U P   ----------------------------------------------------------------------
void setup()
{
  Serial.begin(9600);

  // przyciski pulpitu //
  pinMode(key_a1, INPUT_PULLUP);
  pinMode(key_a2, INPUT_PULLUP);
  pinMode(key_b1, INPUT_PULLUP);
  pinMode(key_c2, INPUT_PULLUP);
  pinMode(key_d1, INPUT_PULLUP);
  pinMode(key_e2, INPUT_PULLUP);
  pinMode(key_f1, INPUT_PULLUP);
  pinMode(key_f2, INPUT_PULLUP);

  pinMode(key_rozw_przebiegu_1, INPUT_PULLUP);
  pinMode(key_rozw_przebiegu_2, INPUT_PULLUP);

  pinMode(key_Zw1, INPUT_PULLUP);
  pinMode(key_Zw2, INPUT_PULLUP);
  pinMode(key_Zw3_4, INPUT_PULLUP);
  pinMode(key_Zw5, INPUT_PULLUP);
  pinMode(key_Wk, INPUT_PULLUP);

  pinMode(key_SzA, INPUT_PULLUP);
  pinMode(key_SzB, INPUT_PULLUP);
  pinMode(key_SzC, INPUT_PULLUP);
  pinMode(key_SzD, INPUT_PULLUP);
  pinMode(key_SzE, INPUT_PULLUP);
  pinMode(key_SzF, INPUT_PULLUP);


  // diody pulpitu //
  pinMode(led_A_czerwone, OUTPUT);
  pinMode(led_A_zielone, OUTPUT);
  pinMode(led_A_biale, OUTPUT);
  digitalWrite(led_A_czerwone, HIGH);
  digitalWrite(led_A_zielone, LOW);
  digitalWrite(led_A_biale, LOW);

  pinMode(led_B_czerwone, OUTPUT);
  pinMode(led_B_zielone, OUTPUT);
  pinMode(led_B_biale, OUTPUT);
  digitalWrite(led_B_czerwone, HIGH);
  digitalWrite(led_B_zielone, LOW);
  digitalWrite(led_B_biale, LOW);

  pinMode(led_C_czerwone, OUTPUT);
  pinMode(led_C_zielone, OUTPUT);
  pinMode(led_C_biale, OUTPUT);
  digitalWrite(led_C_czerwone, HIGH);
  digitalWrite(led_C_zielone, LOW);
  digitalWrite(led_C_biale, LOW);

  pinMode(led_D_czerwone, OUTPUT);
  pinMode(led_D_zielone, OUTPUT);
  pinMode(led_D_biale, OUTPUT);
  digitalWrite(led_D_czerwone, HIGH);
  digitalWrite(led_D_zielone, LOW);
  digitalWrite(led_D_biale, LOW);

  pinMode(led_E_czerwone, OUTPUT);
  pinMode(led_E_zielone, OUTPUT);
  pinMode(led_E_biale, OUTPUT);
  digitalWrite(led_F_czerwone, HIGH);
  digitalWrite(led_F_zielone, LOW);
  digitalWrite(led_F_biale, LOW);

  pinMode(led_Zw1_plus, OUTPUT);
  pinMode(led_Zw1_minus, OUTPUT);
  pinMode(led_Zw2_plus, OUTPUT);
  pinMode(led_Zw2_minus, OUTPUT);
  pinMode(led_Zw3_4_plus, OUTPUT);
  pinMode(led_Zw3_4_minus, OUTPUT);
  pinMode(led_Zw5_plus, OUTPUT);
  pinMode(led_Zw5_minus, OUTPUT);
  digitalWrite(led_Zw1_plus, HIGH);
  digitalWrite(led_Zw1_minus, LOW);
  digitalWrite(led_Zw2_plus, HIGH);
  digitalWrite(led_Zw2_minus, LOW);
  digitalWrite(led_Zw3_4_plus, HIGH);
  digitalWrite(led_Zw3_4_minus, LOW);
  digitalWrite(led_Zw5_plus, HIGH);
  digitalWrite(led_Zw5_minus, LOW);

  pinMode(led_a1, OUTPUT);
  pinMode(led_a2, OUTPUT);
  pinMode(led_b1, OUTPUT);
  pinMode(led_c2, OUTPUT);
  pinMode(led_d1, OUTPUT);
  pinMode(led_e2, OUTPUT);
  pinMode(led_f1, OUTPUT);
  pinMode(led_f2, OUTPUT);
  digitalWrite(led_a1, LOW);
  digitalWrite(led_a2, LOW);
  digitalWrite(led_b1, LOW);
  digitalWrite(led_c2, LOW);
  digitalWrite(led_d1, LOW);
  digitalWrite(led_e2, LOW);
  digitalWrite(led_f1, LOW);
  digitalWrite(led_f1, LOW);

  pinMode(led_Wk_otwarta, OUTPUT);
  pinMode(led_Wk_zamknieta, OUTPUT);
  digitalWrite(led_Wk_otwarta, LOW);
  digitalWrite(led_Wk_zamknieta, HIGH);

  pinMode(buzzer, OUTPUT);
  digitalWrite(buzzer, HIGH);
  delay(100);
  digitalWrite(buzzer, LOW);
  delay(100);
  digitalWrite(buzzer, HIGH);
  delay(100);
  digitalWrite(buzzer, LOW);

  wyswietl_stan_urzadzen();

} // koniec bloku setup //




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------   B E E P   -----------------------------------------------------------------------
void beep()
{
  digitalWrite(buzzer, HIGH);
  delay(250);
  digitalWrite(buzzer, LOW);
  delay(250);
}




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------   O D C Z Y T    S E R I A L A   ---------------------------------------------------------------
void odczyt_seriala()
{
  data = Serial.parseInt();

  // rozjazdy //
  if (data == 4011)stan_Zw1 = 1;    // na wprost (plus) //
  if (data == 4012)stan_Zw1 = 2;    // na bok (minus) //
  if (data == 4021)stan_Zw2 = 1;
  if (data == 4022)stan_Zw2 = 2;
  if (data == 5011)stan_Zw3_4 = 1;
  if (data == 5012)stan_Zw3_4 = 2;
  if (data == 6011)stan_Zw5 = 1;
  if (data == 6012)stan_Zw5 = 2;

  // wykolejnica //
  if (data == 4031)stan_Wk = 1;     // otwarta //
  if (data == 4032)stan_Wk = 2;     // zamknieta //

  // semafory //
  if (data == 4041)stan_A = 1;      // S1 czerwone //
  if (data == 4042)stan_A = 2;      // S2 zielone //
  if (data == 4043)stan_A = 3;      // Sz biale //
  if (data == 4044)stan_A = 4;      // S5 pomaranczowe //
  if (data == 4045)stan_A = 5;      // S13 2*pomaranczowe //
  if (data == 4046)stan_A = 6;      // S12 2*pom / miganie //
  if (data == 4047)stan_A = 7;      // S10 zielone + pomaranczowe //

  if (data == 4051)stan_B = 1;      // S1 //
  if (data == 4052)stan_B = 2;      // S2 //
  if (data == 4053)stan_B = 3;      // Sz //

  if (data == 4061)stan_C = 1;      // S1 //
  if (data == 4062)stan_C = 2;      // S2 //
  if (data == 4063)stan_C = 3;      // Sz //
  if (data == 4064)stan_C = 4;      // S10 //

  if (data == 6021)stan_D = 1;      // S1 //
  if (data == 6022)stan_D = 2;      // S2 //
  if (data == 6023)stan_D = 3;      // Sz //

  if (data == 6031)stan_E = 1;      // S1 //
  if (data == 6032)stan_E = 2;      // S2 //
  if (data == 6033)stan_E = 3;      // Sz //
  if (data == 6034)stan_E = 4;      // S10 //

  if (data == 6041)stan_F = 1;      // S1 czerwone //
  if (data == 6042)stan_F = 2;      // S2 zielone //
  if (data == 6043)stan_F = 3;      // Sz biale //
  if (data == 6044)stan_F = 4;      // S5 pomaranczowe //
  if (data == 6045)stan_F = 5;      // S13 2*pomaranczowe //
  if (data == 6046)stan_F = 6;      // S12 2*pom / miganie //
  if (data == 6047)stan_F = 7;      // S10 zielone + pomaranczowe //

  wyswietl_stan_urzadzen();
}




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------   WYSWIETL STAN URZADZEN   ---------------------------------------------------------------
void wyswietl_stan_urzadzen()
{
  if (stan_Zw1 == 1) {
    digitalWrite(led_Zw1_plus, HIGH);
    digitalWrite(led_Zw1_minus, LOW);
  }
  if (stan_Zw1 == 2) {
    digitalWrite(led_Zw1_plus, LOW);
    digitalWrite(led_Zw1_minus, HIGH);
  }
  if (stan_Zw2 == 1) {
    digitalWrite(led_Zw2_plus, HIGH);
    digitalWrite(led_Zw2_minus, LOW);
  }
  if (stan_Zw2 == 2) {
    digitalWrite(led_Zw2_plus, LOW);
    digitalWrite(led_Zw2_minus, HIGH);
  }
  if (stan_Zw3_4 == 1) {
    digitalWrite(led_Zw3_4_plus, HIGH);
    digitalWrite(led_Zw3_4_minus, LOW);
  }
  if (stan_Zw3_4 == 2) {
    digitalWrite(led_Zw3_4_plus, LOW);
    digitalWrite(led_Zw3_4_minus, HIGH);
  }
  if (stan_Zw5 == 1) {
    digitalWrite(led_Zw5_plus, HIGH);
    digitalWrite(led_Zw5_minus, LOW);
  }
  if (stan_Zw5 == 2) {
    digitalWrite(led_Zw5_plus, LOW);
    digitalWrite(led_Zw5_minus, HIGH);
  }

  if (stan_Wk == 1) {
    digitalWrite(led_Wk_otwarta, HIGH);
    digitalWrite(led_Wk_zamknieta, LOW);
  }
  if (stan_Wk == 2) {
    digitalWrite(led_Wk_otwarta, LOW);
    digitalWrite(led_Wk_zamknieta, HIGH);
  }

  if (stan_A == 1) {
    digitalWrite(led_A_czerwone, HIGH);
    digitalWrite(led_A_zielone, LOW);
    digitalWrite(led_A_biale, LOW);
  }
  if (stan_A == 2 || stan_A == 4 || stan_A == 5 || stan_A == 6 || stan_A == 7) {
    digitalWrite(led_A_czerwone, LOW);
    digitalWrite(led_A_zielone, HIGH);
    digitalWrite(led_A_biale, LOW);
  }
  if (stan_A == 3) {
    digitalWrite(led_A_czerwone, LOW);
    digitalWrite(led_A_zielone, LOW);
    digitalWrite(led_A_biale, HIGH);
  }

  if (stan_B == 1) {
    digitalWrite(led_B_czerwone, HIGH);
    digitalWrite(led_B_zielone, LOW);
    digitalWrite(led_B_biale, LOW);
  }
  if (stan_B == 2) {
    digitalWrite(led_B_czerwone, LOW);
    digitalWrite(led_B_zielone, HIGH);
    digitalWrite(led_B_biale, LOW);
  }
  if (stan_B == 3) {
    digitalWrite(led_B_czerwone, LOW);
    digitalWrite(led_B_zielone, LOW);
    digitalWrite(led_B_biale, HIGH);
  }

  if (stan_C == 1) {
    digitalWrite(led_C_czerwone, HIGH);
    digitalWrite(led_C_zielone, LOW);
    digitalWrite(led_C_biale, LOW);
  }
  if (stan_C == 2 || stan_C == 4) {
    digitalWrite(led_C_czerwone, LOW);
    digitalWrite(led_C_zielone, HIGH);
    digitalWrite(led_C_biale, LOW);
  }
  if (stan_C == 3) {
    digitalWrite(led_C_czerwone, LOW);
    digitalWrite(led_C_zielone, LOW);
    digitalWrite(led_C_biale, HIGH);
  }

  if (stan_D == 1) {
    digitalWrite(led_D_czerwone, HIGH);
    digitalWrite(led_D_zielone, LOW);
    digitalWrite(led_D_biale, LOW);
  }
  if (stan_D == 2) {
    digitalWrite(led_D_czerwone, LOW);
    digitalWrite(led_D_zielone, HIGH);
    digitalWrite(led_D_biale, LOW);
  }
  if (stan_D == 3) {
    digitalWrite(led_D_czerwone, LOW);
    digitalWrite(led_D_zielone, LOW);
    digitalWrite(led_D_biale, HIGH);
  }

  if (stan_E == 1) {
    digitalWrite(led_E_czerwone, HIGH);
    digitalWrite(led_E_zielone, LOW);
    digitalWrite(led_E_biale, LOW);
  }
  if (stan_E == 2 || stan_E == 4) {
    digitalWrite(led_E_czerwone, LOW);
    digitalWrite(led_E_zielone, HIGH);
    digitalWrite(led_E_biale, LOW);
  }
  if (stan_E == 3) {
    digitalWrite(led_E_czerwone, LOW);
    digitalWrite(led_E_zielone, LOW);
    digitalWrite(led_E_biale, HIGH);
  }

  if (stan_F == 1) {
    digitalWrite(led_F_czerwone, HIGH);
    digitalWrite(led_F_zielone, LOW);
    digitalWrite(led_F_biale, LOW);
  }
  if (stan_F == 2 || stan_F == 4 || stan_F == 5 || stan_F == 6 || stan_F == 7) {
    digitalWrite(led_F_czerwone, LOW);
    digitalWrite(led_F_zielone, HIGH);
    digitalWrite(led_F_biale, LOW);
  }
  if (stan_F == 3) {
    digitalWrite(led_F_czerwone, LOW);
    digitalWrite(led_F_zielone, LOW);
    digitalWrite(led_F_biale, HIGH);
  }

} // wyswietl stan urzadzen //





// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------   L O O P   -----------------------------------------------------------------------
void loop()
{
  czas = millis();

  if (Serial.available() > 0)odczyt_seriala();

  if (digitalRead(key_Zw1) == LOW) {
    beep();
    if (utwierdzenie_Zw1 == 0) {
      if (stan_Zw1 == 1)Serial.println(1012);
      if (stan_Zw1 == 2)Serial.println(1011);
    }
  }

  if (digitalRead(key_Zw2) == LOW) {
    beep();
    if (utwierdzenie_Zw2 == 0) {
      if (stan_Zw2 == 1)Serial.println(1022);
      if (stan_Zw2 == 2)Serial.println(1021);
    }
  }

  if (digitalRead(key_Zw3_4) == LOW) {
    beep();
    if (utwierdzenie_Zw3_4 == 0) {
      if (stan_Zw3_4 == 1)Serial.println(2012);
      if (stan_Zw3_4 == 2)Serial.println(2011);
    }
  }

  if (digitalRead(key_Zw5) == LOW) {
    beep();
    if (utwierdzenie_Zw5 == 0) {
      if (stan_Zw5 == 1)Serial.println(3012);
      if (stan_Zw5 == 2)Serial.println(3011);
    }
  }

  if (digitalRead(key_Wk) == LOW) {
    beep();
    if (utwierdzenie_Wk == 0) {
      if (stan_Wk == 1 && stan_Zw2 == 1)Serial.println(1032);
      if (stan_Wk == 2 && stan_Zw2 == 1)Serial.println(1031);
    }
  }


  // ------------------------------------------------------------------------------------------------------------------------------------------------------------
  // przebieg a1 //
  if (digitalRead(key_a1) == LOW) {
    beep();
    if (stan_Zw1 == 1 && stan_Zw2 == 1 && stan_Wk == 1 && stan_Zw3_4 == 1 && stan_Zw5 == 1
        && stan_a1 == 0 && stan_a2 == 0 && stan_b1 == 0 && stan_c2 == 0
        && stan_e2 == 0 && stan_f1 == 0 && stan_f2 == 0) {
      stan_a1 = 1;  // utwierdzenie przebiegu a1 //
      digitalWrite(led_a1, HIGH);
      if (stan_D == 1)Serial.println(1044);     // A >> S5 //
      if (stan_D == 2)Serial.println(1042);     // A >> S2 //
    }
  } // a1 //


  // przebieg a2 //
  if (digitalRead(key_a2) == LOW) {
    beep();
    if (stan_Zw1 == 2 && stan_Zw5 == 2
        && stan_a1 == 0 && stan_a2 == 0 && stan_b1 == 0 && stan_c2 == 0
        && stan_d1 == 0 && stan_f1 == 0 && stan_f2 == 0) {
      stan_a2 = 1;  // utwierdzenie przebiegu a2 //
      digitalWrite(led_a2, HIGH);
      if (stan_E == 1)Serial.println(1045);   // A >> S 13 //
      if (stan_E == 4)Serial.println(1046);   // A >> S 12 //
    }
  } // a2 //



  // przebieg b1 //
  if (digitalRead(key_b1) == LOW) {
    beep();
    if (stan_Zw1 == 1 && stan_Zw2 == 1 && stan_Wk == 1
        && stan_a1 == 0 && stan_a2 == 0 && stan_b1 == 0 && stan_c2 == 0
        && stan_f2 == 0) {
      stan_b1 = 1;    // utwierdzenie przebiegu b1 //
      digitalWrite(led_b1, HIGH);
      Serial.println(1052);   // B >> S2 zielone //

      // jesli przebieg f1 jest juz utwierdzony to zmiana semafora F na zielony
      if (stan_f1 == 1) Serial.println(3042); // F >> S2 zielone //

    }
  } // b1 //



  // przebieg c2 //
  if (digitalRead(key_c2) == LOW) {
    beep();
    if (stan_Zw1 == 2
        && stan_a1 == 0 && stan_a2 == 0 && stan_b1 == 0 && stan_f1 == 0 && stan_c2 == 0) {
      stan_c2 = 1;    // utwierdzenie przebiegu c2 //
      digitalWrite(led_c2, HIGH);
      Serial.println(1064);   // C >> S 10 zielone+pomaranczowe //

      // jesli przebieg f2 jest juz utwierdzony to zmiana semafora F na zielony
      if (stan_f2 == 1) Serial.println(3046);     // F >> S12 //

    }
  } // c2 //



  // przebieg d1 //
  if (digitalRead(key_d1) == LOW) {
    beep();
    if (stan_Zw3_4 == 1 && stan_Zw5 == 1
        && stan_a2 == 0 && stan_e2 == 0 && stan_f1 == 0 && stan_f2 == 0 && stan_d1 == 0) {
      stan_d1 = 1;                  // utwierdzenie przebiegu d1 //
      digitalWrite(led_d1, HIGH);
      Serial.println(3022);         // D >> S2 zielone //

      // jesli przebieg a1 jest juz utwierdzony to zmiana semafora A na zielony
      if (stan_a1 == 1) Serial.println(1042);     // A >> S2 zielone

    }
  } // d1 //



  // przebieg e2 //
  if (digitalRead(key_e2) == LOW) {
    beep();
    if (stan_Zw5 == 2
        && stan_a2 == 0 && stan_d1 == 0 && stan_f1 == 0 && stan_f2 == 0 && stan_e2 == 0) {
      stan_e2 = 1;                  // utwierdzenie przebiegu e2 //
      digitalWrite(led_e2, HIGH);
      Serial.println(3034);         // E >> S10 //

      // jesli przebieg a2 jest juz utwierdzony to zmiana semafora A na zielony
      if (stan_a2 == 1) Serial.println(1046);   // A >> S 12 //

    }
  } // e2 //



  // przebieg f1 //
  if (digitalRead(key_f1) == LOW) {
    beep();
    if (stan_Zw5 == 1 && stan_Zw3_4 == 1 && stan_Zw2 == 1 && stan_Zw1 == 1 && stan_Wk == 1
        && stan_a1 == 0 && stan_a2 == 0 && stan_c2 == 0 && stan_d1 == 0 && stan_e2 == 0 && stan_f2 == 0 && stan_f1 == 0) {
      stan_f1 = 1;                          // utwierdzenie przebiegu f1 //
      digitalWrite(led_f1, HIGH);
      if (stan_B == 1)Serial.println(3044); // F >> S5 pomaranczowe //
      if (stan_B == 2)Serial.println(3042); // F >> S2 zielone //
    }
  } // f1 //



  // przebieg f2 //
  if (digitalRead(key_f2) == LOW) {
    beep();
    if (stan_Zw5 == 2 && stan_Zw1 == 2
        && stan_a1 == 0 && stan_a2 == 0 && stan_b1 == 0 && stan_d1 == 0 && stan_e2 == 0  && stan_f1 == 0 && stan_f2 == 0) {
      stan_f2 = 1;                            // utwierdzenie przebiegu f2 //
      digitalWrite(led_f2, HIGH);
      if (stan_C == 1)Serial.println(3045);     // F >> S13 2*pomaranczowe //
      if (stan_C == 4)Serial.println(3046);     // F >> S12 //
    }
  } // f2 //




  // ------------------------------------------------------------------------------------------------------------------------------------------------------------
  // rozwiazywanie przebiegow //
  if (digitalRead(key_rozw_przebiegu_1) == LOW) {
    beep();
    stan_a1 = 0;
    stan_a2 = 0;
    stan_b1 = 0;
    stan_c2 = 0;
    stan_SzA = 0;
    stan_SzB = 0;
    stan_SzC = 0;
    digitalWrite(led_a1, LOW);
    digitalWrite(led_a2, LOW);
    digitalWrite(led_b1, LOW);
    digitalWrite(led_c2, LOW);
    Serial.println(1041);
    Serial.println(1051);
    Serial.println(1061);

    // zmiana semafora F jesli podany jest wjazd
    if (stan_f1 == 1)Serial.println(3044);  // F >> S5 pomaranczowe //
    if (stan_f2 == 1)Serial.println(3045);  // F >> S13 2*pomaranczowe //
  }

  if (digitalRead(key_rozw_przebiegu_2) == LOW) {
    beep();
    stan_d1 = 0;
    stan_e2 = 0;
    stan_f1 = 0;
    stan_f2 = 0;
    stan_SzD = 0;
    stan_SzE = 0;
    stan_SzF = 0;
    digitalWrite(led_d1, LOW);
    digitalWrite(led_e2, LOW);
    digitalWrite(led_f1, LOW);
    digitalWrite(led_f2, LOW);
    Serial.println(3021);
    Serial.println(3031);
    Serial.println(3041);

    // zmiana semafora A jesli podany jest wjazd
    if (stan_a1 == 1)Serial.println(1044);     // A >> S5 //
    if (stan_a2 == 1)Serial.println(1045);   // A >> S 13 //
  }




  // ------------------------------------------------------------------------------------------------------------------------------------------------------------
  // Sygnaly zastepcze //


  if (digitalRead(key_SzA) == LOW) {
    beep();
    if (stan_SzA == 0)Serial.println(1043);
    stan_SzA = 1;
    czas_SzA = czas + 10000;
  }

  if (digitalRead(key_SzB) == LOW) {
    beep();
    if (stan_SzB == 0)Serial.println(1053);
    stan_SzB = 1;
    czas_SzB = czas + 10000;
  }

  if (digitalRead(key_SzC) == LOW) {
    beep();
    if (stan_SzC == 0)Serial.println(1063);
    stan_SzC = 1;
    czas_SzC = czas + 10000;
  }

  if (digitalRead(key_SzD) == LOW) {
    beep();
    if (stan_SzD == 0)Serial.println(3023);
    stan_SzD = 1;
    czas_SzD = czas + 10000;
  }


  if (digitalRead(key_SzE) == LOW) {
    beep();
    if (stan_SzE == 0)Serial.println(3033);
    stan_SzE = 1;
    czas_SzE = czas + 10000;
  }

  if (digitalRead(key_SzF) == LOW) {
    beep();
    if (stan_SzF == 0)Serial.println(3043);
    stan_SzF = 1;
    czas_SzF = czas + 10000;
  }


  if (czas > czas_SzA && stan_SzA > 0) {
    stan_SzA = 0;
    Serial.println(1041);
  }

  if (czas > czas_SzB && stan_SzB > 0) {
    stan_SzB = 0;
    Serial.println(1051);
  }

  if (czas > czas_SzC && stan_SzC > 0) {
    stan_SzC = 0;
    Serial.println(1061);
  }

  if (czas > czas_SzD && stan_SzD > 0) {
    stan_SzD = 0;
    Serial.println(3021);
  }

  if (czas > czas_SzE && stan_SzE > 0) {
    stan_SzE = 0;
    Serial.println(3031);
  }

  if (czas > czas_SzF && stan_SzF > 0) {
    stan_SzF = 0;
    Serial.println(3041);
  }

  // ------------------------------------------------------------------------------------------------------------------------------------------------------------
  // utwierdzenia rozjazdow i wykolejnicy //
  if (stan_a1 == 1 || stan_a2 == 1 || stan_b1 == 1 || stan_c2 == 1 || stan_f1 == 1 || stan_f2 == 1) utwierdzenie_Zw1 = 1; else utwierdzenie_Zw1 = 0;
  if (stan_a1 == 1 || stan_b1 == 1 || stan_f1 == 1 || stan_Wk == 1) utwierdzenie_Zw2 = 1; else utwierdzenie_Zw2 = 0;
  if (stan_a1 == 1 || stan_d1 == 1 || stan_f1 == 1 ) utwierdzenie_Zw3_4 = 1; else utwierdzenie_Zw3_4 = 0;
  if (stan_a1 == 1 || stan_a2 == 1 || stan_d1 == 1 || stan_e2 == 1 || stan_f1 == 1 || stan_f2 == 1) utwierdzenie_Zw5 = 1; else utwierdzenie_Zw5 = 0;
  if (stan_a1 == 1 || stan_b1 == 1 || stan_f1 == 1) utwierdzenie_Wk == 1; else utwierdzenie_Wk = 0;



} // loop //
